## blis 0.5.2

=== Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Top-level makefile for libflame linear algebra library.
#
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        libs libblis \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        flat-header flat-cblas-header \
        test \
        testblas blastest-f2c blastest-bin blastest-run \
        testsuite testsuite-bin \
        testsuite-run testsuite-run-fast testsuite-run-md testsuite-run-salt \
        testblis testblis-fast testblis-md testblis-salt \
        check checkblas \
        checkblis checkblis-fast checkblis-md checkblis-salt \
        install-headers install-libs install-lib-symlinks \
        showconfig \
        clean cleanmk cleanh cleanlib distclean \
        cleantest cleanblastest cleanblistest \
        changelog \
        install uninstall uninstall-old \
        uninstall-libs uninstall-lib-symlinks uninstall-headers \
        uninstall-old-libs uninstall-lib-symlinks uninstall-old-headers

#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - We don't need to define DIST_PATH, LIB_PATH, INC_PATH, or SHARE_PATH since
#   the defaults in common.mk (and config.mk) are designed to work with the
#   top-level Makefile.
#DIST_PATH  := .
#LIB_PATH    = ./lib/$(CONFIG_NAME)
#INC_PATH    = ./include/$(CONFIG_NAME)
#SHARE_PATH := .


#
# --- Include common makefile definitions --------------------------------------
#

# Define the name of the common makefile.
COMMON_MK_FILE    := common.mk

# Include the configuration file.
-include $(COMMON_MK_FILE)

# Detect whether we actually got the configuration file. If we didn't, then
# it is likely that the user has not yet generated it (via configure).
ifeq ($(strip $(COMMON_MK_INCLUDED)),yes)
COMMON_MK_PRESENT := yes
else
COMMON_MK_PRESENT := no
endif



#
# --- Main target variable definitions -----------------------------------------
#

# --- Object file paths ---

# Construct the base object file path for the current configuration.
BASE_OBJ_PATH          := ./$(OBJ_DIR)/$(CONFIG_NAME)

# Construct base object file paths corresponding to the four locations
# of source code.
BASE_OBJ_CONFIG_PATH   := $(BASE_OBJ_PATH)/$(CONFIG_DIR)
BASE_OBJ_FRAME_PATH    := $(BASE_OBJ_PATH)/$(FRAME_DIR)
BASE_OBJ_REFKERN_PATH  := $(BASE_OBJ_PATH)/$(REFKERN_DIR)
BASE_OBJ_KERNELS_PATH  := $(BASE_OBJ_PATH)/$(KERNELS_DIR)
BASE_OBJ_SANDBOX_PATH  := $(BASE_OBJ_PATH)/$(SANDBOX_DIR)

# --- Define install target names for static libraries ---

LIBBLIS_A_INST            := $(INSTALL_LIBDIR)/$(LIBBLIS_A)

# --- Define install target names for shared libraries ---

LIBBLIS_SO_INST           := $(INSTALL_LIBDIR)/$(LIBBLIS_SO)
LIBBLIS_SO_MAJ_INST       := $(INSTALL_LIBDIR)/$(LIBBLIS_SONAME)

ifeq ($(IS_WIN),yes)
# The 'install' target does not create symlinks for Windows builds, so we don't
# bother defining LIBBLIS_SO_MMB_INST.
LIBBLIS_SO_MMB_INST       :=
else
LIBBLIS_SO_MMB_INST       := $(INSTALL_LIBDIR)/$(LIBBLIS).$(LIBBLIS_SO_MMB_EXT)
endif

# --- Determine which libraries to build ---

MK_LIBS                   :=
MK_LIBS_INST              :=
MK_LIBS_SYML              :=

ifeq ($(MK_ENABLE_STATIC),yes)
MK_LIBS                   += $(LIBBLIS_A_PATH)
MK_LIBS_INST              += $(LIBBLIS_A_INST)
MK_LIBS_SYML              +=
endif
ifeq ($(MK_ENABLE_SHARED),yes)
MK_LIBS                   += $(LIBBLIS_SO_PATH) \
                             $(LIBBLIS_SO_MAJ_PATH)
MK_LIBS_INST              += $(LIBBLIS_SO_MMB_INST)
MK_LIBS_SYML              += $(LIBBLIS_SO_INST) \
                             $(LIBBLIS_SO_MAJ_INST)
endif

# Strip leading, internal, and trailing whitespace.
MK_LIBS_INST              := $(strip $(MK_LIBS_INST))
MK_LIBS_SYML              := $(strip $(MK_LIBS_SYML))

# --- Define install directory for headers ---

# Set the path to the subdirectory of the include installation directory.
MK_INCL_DIR_INST          := $(INSTALL_INCDIR)/blis

# --- Define install directory for public makefile fragments ---

# Set the path to the subdirectory of the share installation directory.
MK_SHARE_DIR_INST         := $(INSTALL_SHAREDIR)/blis



#
# --- Library object definitions -----------------------------------------------
#

# In this section, we will isolate the relevant source code filepaths and
# convert them to lists of object filepaths. Relevant source code falls into
# four categories: configuration source; architecture-specific kernel source;
# reference kernel source; and general framework source.

# $(call gen-obj-paths-from-src file_exts, src_files, base_src_path, base_obj_path)
gen-obj-paths-from-src = $(foreach ch, $(1), \
                             $(patsubst $(3)/%.$(ch), \
                                        $(4)/%.o, \
                                        $(filter %.$(ch), $(2)) ) )

# Generate object file paths for source code found in the sub-configuration
# directories.
MK_CONFIG_OBJS      := $(call gen-obj-paths-from-src,$(CONFIG_SRC_SUFS),$(MK_CONFIG_SRC),$(CONFIG_PATH),$(BASE_OBJ_CONFIG_PATH))

# Generate object file paths for architecture-specific kernel source code.
# We target only .c, .s, and .S files. Note that MK_KERNELS_SRC is already
# limited to the kernel source corresponding to the kernel sets in
# KERNEL_LIST. This is because the configure script only propogated makefile
# fragments into those specific kernel subdirectories.
MK_KERNELS_OBJS     := $(call gen-obj-paths-from-src,$(KERNELS_SRC_SUFS),$(MK_KERNELS_SRC),$(KERNELS_PATH),$(BASE_OBJ_KERNELS_PATH))

# Generate object file paths for reference kernels, with one set of object
# files for each sub-configuration in CONFIG_LIST. Note that due to the
# nuances of naming the reference kernel files, we can't use the function
# gen-obj-paths-from-src as we do above and below.
MK_REFKERN_C        := $(filter %.c, $(MK_REFKERN_SRC))
MK_REFKERN_OBJS     := $(foreach arch, $(CONFIG_LIST), \
                           $(patsubst $(REFKERN_PATH)/%_$(REFNM).c, \
                                 $(BASE_OBJ_REFKERN_PATH)/$(arch)/%_$(arch)_$(REFNM).o, \
                                 $(MK_REFKERN_C) \
                            ) \
                        )

# Generate object file paths for all of the portable framework source code.
MK_FRAME_OBJS       := $(call gen-obj-paths-from-src,$(FRAME_SRC_SUFS),$(MK_FRAME_SRC),$(FRAME_PATH),$(BASE_OBJ_FRAME_PATH))

# Generate object file paths for the sandbox source code. If a sandbox was not
# enabled a configure-time, this variable will we empty.
MK_SANDBOX_OBJS     := $(call gen-obj-paths-from-src,$(SANDBOX_SRC_SUFS),$(MK_SANDBOX_SRC),$(SANDBOX_PATH),$(BASE_OBJ_SANDBOX_PATH))

# Combine all of the object files into some readily-accessible variables.
MK_BLIS_OBJS        := $(MK_CONFIG_OBJS) \
                       $(MK_KERNELS_OBJS) \
                       $(MK_REFKERN_OBJS) \
                       $(MK_FRAME_OBJS) \
                       $(MK_SANDBOX_OBJS)

# Optionally filter out the BLAS and CBLAS compatibility layer object files.
# This is not actually necessary, since each affected file is guarded by C
# preprocessor macros, but it but prevents "empty" object files from being
# added into the library (and reduces compilation time).
BASE_OBJ_BLAS_PATH  := $(BASE_OBJ_FRAME_PATH)/compat
BASE_OBJ_CBLAS_PATH := $(BASE_OBJ_FRAME_PATH)/compat/cblas
ifeq ($(MK_ENABLE_CBLAS),no)
MK_BLIS_OBJS        := $(filter-out $(BASE_OBJ_CBLAS_PATH)/%.o, $(MK_BLIS_OBJS) )
endif
ifeq ($(MK_ENABLE_BLAS),no)
MK_BLIS_OBJS        := $(filter-out $(BASE_OBJ_BLAS_PATH)/%.o,  $(MK_BLIS_OBJS) )
endif



#
# --- Monolithic header definitions --------------------------------------------
#

# Define a list of headers to install. The default is to only install blis.h.
HEADERS_TO_INSTALL := $(BLIS_H_FLAT)

# If CBLAS is enabled, we also install cblas.h so the user does not need to
# change their source code to #include "blis.h" in order to access the CBLAS
# function prototypes and enums.
ifeq ($(MK_ENABLE_CBLAS),yes)
HEADERS_TO_INSTALL += $(CBLAS_H_FLAT)
endif



#
# --- public makefile fragment definitions -------------------------------------
#

# Define a list of makefile fragments to install.
FRAGS_TO_INSTALL := $(CONFIG_MK_FILE) \
                    $(COMMON_MK_FILE)



#
# --- BLAS test drivers definitions --------------------------------------------
#

# The location of the BLAS test suite's input files.
BLASTEST_INPUT_PATH    := $(DIST_PATH)/$(BLASTEST_DIR)/input

# The location of the BLAS test suite object directory.
BASE_OBJ_BLASTEST_PATH := $(BASE_OBJ_PATH)/$(BLASTEST_DIR)

# The locations of the BLAS test suite source code (f2c and drivers).
BLASTEST_F2C_SRC_PATH  := $(DIST_PATH)/$(BLASTEST_DIR)/f2c
BLASTEST_DRV_SRC_PATH  := $(DIST_PATH)/$(BLASTEST_DIR)/src

# The paths to object files we will create (f2c and drivers).
BLASTEST_F2C_OBJS      := $(sort \
                          $(patsubst $(BLASTEST_F2C_SRC_PATH)/%.c, \
                                     $(BASE_OBJ_BLASTEST_PATH)/%.o, \
                                     $(wildcard $(BLASTEST_F2C_SRC_PATH)/*.c)) \
                           )

BLASTEST_DRV_OBJS      := $(sort \
                          $(patsubst $(BLASTEST_DRV_SRC_PATH)/%.c, \
                                     $(BASE_OBJ_BLASTEST_PATH)/%.o, \
                                     $(wildcard $(BLASTEST_DRV_SRC_PATH)/*.c)) \
                           )

# libf2c name and location.
BLASTEST_F2C_LIB_NAME  := libf2c.a
BLASTEST_F2C_LIB       := $(BASE_OBJ_BLASTEST_PATH)/$(BLASTEST_F2C_LIB_NAME)

# The base names of each driver source file (ie: filename minus suffix).
BLASTEST_DRV_BASES     := $(basename $(notdir $(BLASTEST_DRV_OBJS)))

# The binary executable driver names.
BLASTEST_DRV_BINS      := $(addsuffix .x,$(BLASTEST_DRV_BASES))
BLASTEST_DRV_BIN_PATHS := $(addprefix $(BASE_OBJ_BLASTEST_PATH)/,$(BLASTEST_DRV_BINS))

# Binary executable driver "run-" names
BLASTEST_DRV_BINS_R    := $(addprefix run-,$(BLASTEST_DRV_BASES))

# Filter level-1, level-2, and level-3 names to different variables.
BLASTEST_DRV1_BASES    := $(filter %1,$(BLASTEST_DRV_BASES))
BLASTEST_DRV2_BASES    := $(filter %2,$(BLASTEST_DRV_BASES))
BLASTEST_DRV3_BASES    := $(filter %3,$(BLASTEST_DRV_BASES))

=== testsuite/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for BLIS testsuite.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all bin clean \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        run run-amd64 run-x86 run-arm



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif


#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := src
TEST_OBJ_PATH  := obj

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Binary executable name.
TESTSUITE_BIN  := test_libblis.x



#
# --- Targets/rules ------------------------------------------------------------
#

# --- Primary targets ---

all: check-env bin

bin: check-env $(TESTSUITE_BIN)


# --- Environment check rules ---

check-env: check-env-make-defs check-env-fragments check-env-config-mk

check-env-config-mk:
ifeq ($(CONFIG_MK_PRESENT),no)
    $(error Cannot proceed: config.mk not detected! Run configure first)
endif

check-env-make-defs: check-env-fragments
ifeq ($(MAKE_DEFS_MK_PRESENT),no)
    $(error Cannot proceed: make_defs.mk not detected! Invalid configuration)
endif


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif


# -- Executable file rules --

$(TESTSUITE_BIN): $(TEST_OBJS) $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER) $(TEST_OBJS) $(LIBBLIS_LINK) $(LDFLAGS) -o $@
else
	@echo "Linking $@ against '$(LIBBLIS_LINK) $(LDFLAGS)'"
	@$(LINKER) $(TEST_OBJS) $(LIBBLIS_LINK) $(LDFLAGS) -o $@
endif


# -- Test run/check rules --

run: $(TESTSUITE_BIN)
ifeq ($(ENABLE_VERBOSE),yes)
	./$(TESTSUITE_BIN) > $(TESTSUITE_OUT_FILE)

else
	@echo "Running $(TESTSUITE_BIN) with output redirected to '$(TESTSUITE_OUT_FILE)'"
	@./$(TESTSUITE_BIN) > $(TESTSUITE_OUT_FILE)
endif

run-fast: $(TESTSUITE_BIN)
ifeq ($(ENABLE_VERBOSE),yes)
	./$(TESTSUITE_BIN) -g $(TESTSUITE_FAST_GEN) -o $(TESTSUITE_FAST_OPS) > $(TESTSUITE_OUT_FILE)

else
	@echo "Running $(TESTSUITE_BIN) (fast) with output redirected to '$(TESTSUITE_OUT_FILE)'"
	@./$(TESTSUITE_BIN) -g $(TESTSUITE_FAST_GEN) -o $(TESTSUITE_FAST_OPS) > $(TESTSUITE_OUT_FILE)
endif

check: run
ifeq ($(ENABLE_VERBOSE),yes)
	- $(TESTSUITE_CHECK) $(TESTSUITE_OUT_FILE)
else
	@- $(TESTSUITE_CHECK) $(TESTSUITE_OUT_FILE)
endif

check-fast: run-fast
ifeq ($(ENABLE_VERBOSE),yes)
	- $(TESTSUITE_CHECK) $(TESTSUITE_OUT_FILE)
else
	@- $(TESTSUITE_CHECK) $(TESTSUITE_OUT_FILE)
endif


# -- Clean rules --

clean:
	- $(RM_F) $(TEST_OBJS) $(TESTSUITE_BIN)

=== test/3/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2018, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH   := $(HOME)/flame/lib
#VENDOR_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/mkl/lib/intel64
MKL_LIB_PATH := $(HOME)/intel/mkl/lib/intel64
#VENDOR_LIB_PATH := ${MKLROOT}/lib/intel64
#ICC_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/compiler/lib/intel64

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblasp.a

# ATLAS
#ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
#                  $(HOME_LIB_PATH)/libatlas.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

VENDOR_LIB     := $(MKL_LIB)
VENDORP_LIB    := $(MKLP_LIB)


#
# --- Problem size definitions -------------------------------------------------
#

# Single core (single-threaded)
PS_BEGIN := 48
PS_MAX   := 2400
PS_INC   := 48

# Single-socket (multithreaded)
P1_BEGIN := 120
P1_MAX   := 6000
P1_INC   := 120

# Dual-socket (multithreaded)
P2_BEGIN := 160
P2_MAX   := 8000
P2_INC   := 160


#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS

# Complex implementation type
D3MHW    := -DIND=BLIS_3MH
D3M1     := -DIND=BLIS_3M1
D4MHW    := -DIND=BLIS_4MH
D4M1B    := -DIND=BLIS_4M1B
D4M1A    := -DIND=BLIS_4M1A
D1M      := -DIND=BLIS_1M
DNAT     := -DIND=BLIS_NAT

# Implementation string
#STR_3MHW := -DSTR=\"3mhw\"
#STR_3M1  := -DSTR=\"3m1\"
#STR_4MHW := -DSTR=\"4mhw\"
#STR_4M1B := -DSTR=\"4m1b\"
#STR_4M1A := -DSTR=\"4m1a\"
#STR_1M   := -DSTR=\"1m\"
STR_NAT  := -DSTR=\"asm_blis\"
STR_OBL  := -DSTR=\"openblas\"
STR_VEN  := -DSTR=\"vendor\"

# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_1S   := -DTHR_STR=\"1s\"
STR_2S   := -DTHR_STR=\"2s\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=$(PS_BEGIN)  -DP_INC=$(PS_INC)  -DP_MAX=$(PS_MAX)
PDEF_1S  := -DP_BEGIN=$(P1_BEGIN) -DP_INC=$(P1_INC) -DP_MAX=$(P1_MAX)
PDEF_2S  := -DP_BEGIN=$(P2_BEGIN) -DP_INC=$(P2_INC) -DP_MAX=$(P2_MAX)



#
# --- Targets/rules ------------------------------------------------------------
#

all:        all-st all-1s all-2s
blis:       blis-st blis-1s blis-2s
openblas:   openblas-st openblas-1s openblas-2s
vendor:     vendor-st vendor-1s vendor-2s
mkl:        vendor
armpl:      vendor

all-st:     blis-st openblas-st mkl-st
all-1s:     blis-1s openblas-1s mkl-1s
all-2s:     blis-2s openblas-2s mkl-2s

blis-st:    blis-nat-st
blis-1s:    blis-nat-1s
blis-2s:    blis-nat-2s

#blis-ind:   blis-ind-st blis-ind-mt
blis-nat:   blis-nat-st blis-nat-1s blis-nat-2s

# Define the datatypes, operations, and implementations.
DTS   := s d c z
OPS   := gemm hemm herk trmm trsm
IMPLS := asm_blis openblas vendor

# Define functions to construct object filenames from the datatypes and
# operations given an implementation. We define one function for single-
# threaded, single-socket, and dual-socket filenames.
get-st-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(PS_MAX)_$(1)_st.o))
get-1s-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(P1_MAX)_$(1)_1s.o))
get-2s-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(P2_MAX)_$(1)_2s.o))

# Construct object and binary names for single-threaded, single-socket, and
# dual-socket files for BLIS, OpenBLAS, and a vendor library (e.g. MKL).
BLIS_NAT_ST_OBJS := $(call get-st-objs,asm_blis)
BLIS_NAT_ST_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_ST_OBJS))
BLIS_NAT_1S_OBJS := $(call get-1s-objs,asm_blis)
BLIS_NAT_1S_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_1S_OBJS))
BLIS_NAT_2S_OBJS := $(call get-2s-objs,asm_blis)
BLIS_NAT_2S_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_2S_OBJS))

OPENBLAS_ST_OBJS := $(call get-st-objs,openblas)
OPENBLAS_ST_BINS := $(patsubst %.o,%.x,$(OPENBLAS_ST_OBJS))
OPENBLAS_1S_OBJS := $(call get-1s-objs,openblas)
OPENBLAS_1S_BINS := $(patsubst %.o,%.x,$(OPENBLAS_1S_OBJS))
OPENBLAS_2S_OBJS := $(call get-2s-objs,openblas)
OPENBLAS_2S_BINS := $(patsubst %.o,%.x,$(OPENBLAS_2S_OBJS))

VENDOR_ST_OBJS   := $(call get-st-objs,vendor)
VENDOR_ST_BINS   := $(patsubst %.o,%.x,$(VENDOR_ST_OBJS))
VENDOR_1S_OBJS   := $(call get-1s-objs,vendor)
VENDOR_1S_BINS   := $(patsubst %.o,%.x,$(VENDOR_1S_OBJS))
VENDOR_2S_OBJS   := $(call get-2s-objs,vendor)
VENDOR_2S_BINS   := $(patsubst %.o,%.x,$(VENDOR_2S_OBJS))

# Define some targets associated with the above object/binary files.
blis-nat-st: $(BLIS_NAT_ST_BINS)
blis-nat-1s: $(BLIS_NAT_1S_BINS)
blis-nat-2s: $(BLIS_NAT_2S_BINS)

openblas-st: $(OPENBLAS_ST_BINS)
openblas-1s: $(OPENBLAS_1S_BINS)
openblas-2s: $(OPENBLAS_2S_BINS)

vendor-st: $(VENDOR_ST_BINS)
vendor-1s: $(VENDOR_1S_BINS)
vendor-2s: $(VENDOR_2S_BINS)

mkl-st: vendor-st
mkl-1s: vendor-1s
mkl-2s: vendor-2s

armpl-st: vendor-st
armpl-1s: vendor-1s
armpl-2s: vendor-2s

# Mark the object files as intermediate so that make will remove them
# automatically after building the binaries on which they depend.
.INTERMEDIATE: $(BLIS_NAT_ST_OBJS) $(OPENBLAS_ST_OBJS) $(VENDOR_ST_OBJS)
.INTERMEDIATE: $(BLIS_NAT_1S_OBJS) $(OPENBLAS_1S_OBJS) $(VENDOR_1S_OBJS)
.INTERMEDIATE: $(BLIS_NAT_2S_OBJS) $(OPENBLAS_2S_OBJS) $(VENDOR_2S_OBJS)


# --Object file rules --

#$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
#	$(CC) $(CFLAGS) -c $< -o $@

# A function to return the datatype cpp macro def from the datatype
# character.
get-dt-cpp = -DDT=bli_$(1)type

# A function to return other cpp macros that help the test driver
# identify the implementation.
get-bl-cpp = $(strip \
             $(if $(findstring     blis,$(1)),$(STR_NAT) $(BLI_DEF),\
             $(if $(findstring openblas,$(1)),$(STR_OBL) $(BLA_DEF),\
                                              $(STR_VEN) $(BLA_DEF))))

define make-st-rule
test_$(1)$(2)_$(PS_MAX)_$(3)_st.o: test_$(op).c Makefile
	$(CC) $(CFLAGS) $(PDEF_ST) $(call get-dt-cpp,$(1)) $(call get-bl-cpp,$(3)) $(DNAT) $(STR_ST) -c $$< -o $$@
endef

define make-1s-rule
test_$(1)$(2)_$(P1_MAX)_$(3)_1s.o: test_$(op).c Makefile
	$(CC) $(CFLAGS) $(PDEF_1S) $(call get-dt-cpp,$(1)) $(call get-bl-cpp,$(3)) $(DNAT) $(STR_1S) -c $$< -o $$@
endef

define make-2s-rule
test_$(1)$(2)_$(P2_MAX)_$(3)_2s.o: test_$(op).c Makefile
	$(CC) $(CFLAGS) $(PDEF_2S) $(call get-dt-cpp,$(1)) $(call get-bl-cpp,$(3)) $(DNAT) $(STR_2S) -c $$< -o $$@
endef

$(foreach dt,$(DTS), \
$(foreach op,$(OPS), \
$(foreach im,$(IMPLS),$(eval $(call make-st-rule,$(dt),$(op),$(im))))))

$(foreach dt,$(DTS), \
$(foreach op,$(OPS), \
$(foreach im,$(IMPLS),$(eval $(call make-1s-rule,$(dt),$(op),$(im))))))

$(foreach dt,$(DTS), \
$(foreach op,$(OPS), \
$(foreach im,$(IMPLS),$(eval $(call make-2s-rule,$(dt),$(op),$(im))))))


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_%_$(PS_MAX)_openblas_st.x: test_%_$(PS_MAX)_openblas_st.o $(LIBBLIS_LINK)
	$(LINKER) $(strip $<  $(OPENBLAS_LIB)  $(LIBBLIS_LINK) $(LDFLAGS) -o $@)

test_%_$(P1_MAX)_openblas_1s.x: test_%_$(P1_MAX)_openblas_1s.o $(LIBBLIS_LINK)
	$(LINKER) $(strip $<  $(OPENBLASP_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@)

test_%_$(P2_MAX)_openblas_2s.x: test_%_$(P2_MAX)_openblas_2s.o $(LIBBLIS_LINK)
	$(LINKER) $(strip $<  $(OPENBLASP_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@)


test_%_$(PS_MAX)_vendor_st.x:   test_%_$(PS_MAX)_vendor_st.o $(LIBBLIS_LINK)
	$(LINKER) $(strip $<  $(VENDOR_LIB)    $(LIBBLIS_LINK) $(LDFLAGS) -o $@)

=== debian/changelog ===
blis (0.5.2-7) experimental; urgency=medium

  * Also install documentations to the meta -dev packges.
  * Register the markdown documentations in doc-base.
  * Don't mangle name of BLIS's cblas.h header to cblas-blis.h
  * Append CPPFLAGS to CFLAGS, fixing shared object hardening.
  * Add Build-Depends-Package field in symbol files.
  * Remove unused lintian overrides.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 15 Apr 2019 05:41:11 +0000

blis (0.5.2-6) experimental; urgency=medium

  * Install the automatically generated makefiles for each variant.
  * Autopkgtest: Test BLIS with ./testsuite, remove some old tests.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 14 Apr 2019 09:01:59 +0000

blis (0.5.2-5) experimental; urgency=medium

  * Fixup the version script and really hide all bli_* symbols for
    libblas.so.3; Update symbol control files accordingly.
  * Use more variables in d/rules for u-a priority values.
  * Properly guard the test_% target with "nocheck" detector.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 14 Apr 2019 03:34:22 +0000

blis (0.5.2-4) experimental; urgency=medium

  * Make short and long descriptions different for every variant.
  * Remove unused debian/source/lintian-overrides.
  * Collect libblas.so.3 symbols updates from buildd for all archs.
  * Compile on kfreebsd-amd64 with X86_64 configuration.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 13 Apr 2019 16:06:56 +0000

blis (0.5.2-3) experimental; urgency=medium

  * Provide dependency templates for libblas{,64}.so.3 (Closes: #926909)
  * README.Source: Add some memo about the package detail.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 13 Apr 2019 12:47:46 +0000

blis (0.5.2-2) experimental; urgency=medium

  * Refresh symbols for i386, x32 and arm64.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 22 Mar 2019 06:43:21 +0000

blis (0.5.2-1) experimental; urgency=medium

  * New upstream version 0.5.2
  * Add missing B-D to autopkgtest control and add test names.
  * Remove patches merged by upstream, Refresh remaining patches.
  * Fixup symlinks for BLIS64 symbols lists.
  * Refresh BLIS/BLIS64 symbols list for amd64 and generic (ppc64el).

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 21 Mar 2019 03:33:26 +0000

=== debian/control ===
Source: blis
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nico Schlömer <nico.schloemer@gmail.com>,
           Mo Zhou <cdluminate@gmail.com>,
Section: math
Priority: optional
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/blis
Vcs-Git: https://salsa.debian.org/science-team/blis.git
Homepage: https://github.com/flame/blis
Build-Depends: debhelper (>= 12~), python3,

Package: libblis-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2 (= ${binary:Version}), ${misc:Depends},
 libblis-openmp-dev | libblis-pthread-dev | libblis-serial-dev,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files for one of the 32-bit variants.

Package: libblis-openmp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (32bit,openmp) version of development files.

Package: libblis-pthread-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (32bit,pthread) version of development files.

Package: libblis-serial-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2-serial (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,serial)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (32bit,serial) version development files.

Package: libblis2
Architecture: any
Multi-Arch: same
Section: metapackages
Depends: ${misc:Depends}, ${shlibs:Depends},
  libblis2-openmp (= ${binary:Version})
  | libblis2-pthread (= ${binary:Version})
  | libblis2-serial (= ${binary:Version}),
Description: BLAS-like Library Instantiation Software Framework (32bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls one of the 32-bit-Blasint shared library variants.

Package: libblis2-openmp
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Description: BLAS-like Library Instantiation Software Framework (32bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (32bit,openmp) version of shared library.

Package: libblis2-pthread
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Description: BLAS-like Library Instantiation Software Framework (32bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (32bit,pthread) version of shared library.

Package: libblis2-serial
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Description: BLAS-like Library Instantiation Software Framework (32bit,serial)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (32bit,serial) version of shared library.

Package: libblis64-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2 (= ${binary:Version}), ${misc:Depends},
 libblis64-openmp-dev | libblis64-pthread-dev | libblis64-serial-dev,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files for one of the 64-bit variants.

Package: libblis64-openmp-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (64bit,openmp) version of development files.

Package: libblis64-pthread-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (64bit,pthread) version of development files.

Package: libblis64-serial-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2-serial (= ${binary:Version}), ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYTHON=/usr/bin/python3  # for the upstream build system

# Select target architecture
# armhf: upstream's armv7a kernel assumes NEON. Using generic kernels currently.
CONFIG_amd64      = x86_64
CONFIG_arm64      = cortexa57
CONFIG_ppc64el    = generic
CONFIG_kfreebsd-amd64 = x86_64
CONFIG            = $(word 1, $(CONFIG_$(DEB_HOST_ARCH)) generic)

# Update-Alternatives Priority Settings
UAPRI_O = 38
UAPRI_P = 37
UAPRI_S = 36

# SOVERSION (Following upstream)
SOVER := 2

# Threading + Indexing Flavours
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64))
FLAVORS := $(SOVER)-openmp $(SOVER)-pthread $(SOVER)-serial 64-$(SOVER)-openmp 64-$(SOVER)-pthread 64-$(SOVER)-serial
else
FLAVORS := $(SOVER)-openmp $(SOVER)-pthread $(SOVER)-serial
endif

# Common flags for every variant
FLAGS := \
	--enable-verbose-make \
	--prefix=/usr \
	--enable-cblas \
	--enable-static \
	--enable-shared \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

# FLAG Tweaks
export CFLAGS = $(filter-out -O2, $(shell dpkg-buildflags --get CFLAGS)) \
               $(shell dpkg-buildflags --get CPPFLAGS)

##
SRCS := $(filter-out debian $(FLAVORS), $(wildcard ./*))

##


%:
	dh $@ -Smakefile

create_symlinks:
	# BLIS/BLAS
	set -e; cd debian; for j in openmp pthread serial; do \
		ln -sr libblis$(SOVER)-XXX.symbols.generic libblis$(SOVER)-$$j.symbols ;\
		for i in kfreebsd-amd64 amd64 arm64; do  \
			ln -sr libblis$(SOVER)-XXX.symbols.$$i libblis$(SOVER)-$$j.symbols.$$i ;\
		done;\
		for i in i386 x32; do \
			ln -sr libblis$(SOVER)-XXX.symbols.i386 libblis$(SOVER)-$$j.symbols.$$i ;\
		done;\
	done;
	# BLIS64/BLAS64
	set -e; cd debian; for j in openmp pthread serial; do \
		ln -sr libblis64-$(SOVER)-XXX.symbols.generic libblis64-$(SOVER)-$$j.symbols ;\
		for i in kfreebsd-amd64 amd64 arm64; do \
			ln -sr libblis64-$(SOVER)-XXX.symbols.$$i libblis64-$(SOVER)-$$j.symbols.$$i ;\
		done;\
	done;

config_%:
	# Generate maintainer scripts from templates
	set -e; cd debian; if test -z "$$(echo $* | grep 64)"; then \
		cp libblis2-XXX.postinst     libblis$*.postinst; \
		cp libblis2-XXX.prerm        libblis$*.prerm; \
		cp libblis-XXX-dev.postinst  libblis$(subst $(SOVER),,$*)-dev.postinst; \
		cp libblis-XXX-dev.prerm     libblis$(subst $(SOVER),,$*)-dev.prerm; \
		for SCRIPT in libblis$*.postinst libblis$*.prerm \
			libblis$(subst $(SOVER),,$*)-dev.postinst \
			libblis$(subst $(SOVER),,$*)-dev.prerm; do \
			sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
				-e "s/@SUBDIR@/blis$(subst $(SOVER),,$*)/g" \
				-e "s/@SOVER@/$(SOVER)/g" \
				$$SCRIPT; \
			if test -n "$$(echo $* | grep openmp)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_O)/g" $$SCRIPT; \
			elif test -n "$$(echo $* | grep pthread)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_P)/g" $$SCRIPT; \
			else \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_S)/g" $$SCRIPT; \
			fi; \
		done; \
	else \
		cp libblis64-2-XXX.postinst     libblis$*.postinst; \
		cp libblis64-2-XXX.prerm        libblis$*.prerm; \
		cp libblis64-XXX-dev.postinst   libblis$(subst $(SOVER)-,,$*)-dev.postinst; \
		cp libblis64-XXX-dev.prerm      libblis$(subst $(SOVER)-,,$*)-dev.prerm; \
		for SCRIPT in libblis$*.postinst libblis$*.prerm \
			libblis$(subst $(SOVER)-,,$*)-dev.postinst \
			libblis$(subst $(SOVER)-,,$*)-dev.prerm; do \
			sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
				-e "s/@SUBDIR@/blis$(subst $(SOVER)-,,$*)/g" \
				-e "s/@SOVER@/$(SOVER)/g" \
				$$SCRIPT; \
			if test -n "$$(echo $* | grep openmp)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_O)/g" $$SCRIPT; \
			elif test -n "$$(echo $* | grep pthread)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_P)/g" $$SCRIPT; \
			else \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_S)/g" $$SCRIPT; \
			fi; \
		done; \
	fi;
	# Run upstream configure script in duplicated source root directories
	mkdir $*
	cp -r $(SRCS) $*/
	set -e; cd $*; if test -z "$$(echo $* | grep 64)"; then \
		if test -z "$$(echo $* | grep serial)"; then \
			./configure $(FLAGS) -t $(subst $(SOVER)-,,$*) $(CONFIG); \
		else \
			./configure $(FLAGS) --disable-threading $(CONFIG); \
		fi; \
		echo "$*/usr/lib/*/libblis.so.* usr/lib/$(DEB_HOST_MULTIARCH)/" > \
			debian/libblis$*.install; \
	else \
		if test -z "$$(echo $* | grep serial)"; then \
			./configure $(FLAGS) -b 64 -i 64 -t $(subst 64-$(SOVER)-,,$*) $(CONFIG); \
		else \
			./configure $(FLAGS) -b 64 -i 64 --disable-threading $(CONFIG); \
		fi; \
		echo "$*/usr/lib/*/libblis64.so.* usr/lib/$(DEB_HOST_MULTIARCH)/" > \
			debian/libblis$*.install; \
	fi;

override_dh_auto_configure: $(addprefix config_, $(FLAVORS)) create_symlinks
	:

build_%:
	set -e; if test -n "$$(echo $* | grep 64)"; then \
		dh_auto_build -B$* -- DEB_LIBBLAS=libblas64.so.3 LIBBLIS=libblis64 ; \
	else \
		dh_auto_build -B$* -- DEB_LIBBLAS=libblas.so.3; \
	fi;

override_dh_auto_build: $(addprefix build_, $(FLAVORS))
	:

test_%:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; if test -n "$$(echo $* | grep 64)"; then \
		$(MAKE) -C$* check LIBBLIS=libblis64; \
	else \
		$(MAKE) -C$* check; \
	fi;
else
	true  # Or Make won't be able to find the test_% target.
endif

override_dh_auto_test: $(addprefix test_, $(FLAVORS))
	:

install_%:
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*
	# In case we forgot to compile something
	-set -e; if test -n "$$(echo $* | grep 64)"; then \
		dh_auto_install -B$* -- LIBBLIS=libblis64; \
	else \
		dh_auto_install -B$*; \
	fi;
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*

	# Install things manually
	set -e; if test -z "$$(echo $* | grep 64)"; then \
		install -Dm0644 $*/lib/*/libblis.so     debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.so.$(SOVER) ;\
		install -Dm0644 $*/lib/*/libblas.so.3   debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblas.so.3 ;\
		ln -s libblas.so.3                      debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblas.so ;\
		install -Dm0644 $*/lib/*/libblis.a      debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.a ;\
		ln -s libblis.so.$(SOVER)               debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.so ;\
		install -Dm0644 $*/include/*/blis.h     debian/libblis$(subst $(SOVER),,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/blis.h ;\
		install -Dm0644 $*/include/*/cblas.h    debian/libblis$(subst $(SOVER),,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/cblas.h ;\
		mkdir -p            debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/config/$(CONFIG)/;\
		cp -v $*/common.mk  debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/;\
		cp -v $*/config.mk  debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/;\
		cp -v config/$(CONFIG)/make_defs.mk debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/config/$(CONFIG)/;\
	else \
		install -Dm0644 $*/lib/*/libblis64.so   debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblis64.so.$(SOVER) ;\
		install -Dm0644 $*/lib/*/libblas64.so.3 debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblas64.so.3 ;\
		ln -s libblas64.so.3                    debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblas64.so ;\
		install -Dm0644 $*/lib/*/libblis64.a    debian/libblis$(subst $(SOVER)-,,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblis64.a ;\
		ln -s libblis64.so.$(SOVER)             debian/libblis$(subst $(SOVER)-,,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblis64.so ;\
